



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Bridges painting - SGU 121（构造）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Bridges painting - SGU 121（构造）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 05:18:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目大意：有个一无向图，给所有的边染色，如果一个点连接的边超过两个，那么最少要染一个白色和一个黑色，能否给整个图染色？不能输出&ldquo;No solution&rdquo;。</p>
<p>分析：引用连接&nbsp;http://edward-mj.com/archives/445</p>
<p>首先构建dfs树，无向图dfs树具有的一大优点是该点只会向自己的祖先或子孙有非树边。</p>
<p>然后按深度交替染色。返祖边与自己的儿子涂同样的颜色。</p>
<p>如果dfs树中根结点度超过1，那么就找一条边染不同的颜色。</p>
<p>否则看根结点是否满足条件，如果不是，那么找一个与根结点相连的叶子，向上找到一个度大于2的点为止，将该路径上所以边反色，并且将根与该叶子的边反色。如果找不到度大于2的点，那么是奇环，无解。</p>
<p>ps.注意这组数据：</p>
<p>5<br />2 3 0<br />1 3 0<br />1 2 4 5 0<br />3 5 0<br />3 4 0</p>
<p>代码如下：</p>
<p>======================================================================================================================</p>
<div>
<pre class="prettyprint linenums">#include&lt;stdio.h&gt;<br />
#include&lt;string.h&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;vector&gt;<br />
using namespace std;

const int MAXN = ;

int c[MAXN][MAXN], N;///保存边的颜色, N个点<br />
int father[MAXN], nSon[MAXN];<br />
vector&lt;int&gt; e[MAXN];///相连接的点

void DFS(int u, int color)<br />
{<br />
    for(int i=; i&lt;e[u].size(); i++)<br />
    {<br />
        if(c[u][e[u][i]] != -)<br />
            continue;///这条边已经被访问过

        nSon[u]++;///子树数目加1<br />
        c[e[u][i]][u] = c[u][e[u][i]] = color;

        if(!nSon[e[u][i]])<br />
        {///如果不是连接的祖边<br />
            father[e[u][i]] = u;<br />
            DFS(e[u][i], color^);<br />
        }<br />
    }<br />
}

int main()<br />
{<br />
    int i, j, x;

    scanf("%d", &amp;N);

    for(i=; i&lt;=N; i++)<br />
    {<br />
        while(scanf("%d", &amp;x), x)<br />
            e[i].push_back(x);<br />
    }

    memset(c, -, sizeof(c));

    for(i=; i&lt;=N; i++)<br />
    {<br />
        if(nSon[i] || father[i] || e[i].size()==)<br />
            continue;

        ///没有父节点，也没有儿子节点，说明未被访问过<br />
        for(j=; j&lt;e[i].size(); j++)<br />
        {///与根节点连接的第一个节点赋值为颜色0，后面的赋值为别的颜色<br />
            if(j==)<br />
            {<br />
                nSon[i]++, father[e[i][j]] = i;<br />
                c[i][e[i][j]] = c[e[i][j]][i] = ;<br />
                DFS(e[i][j], );<br />
            }<br />
            else if(c[i][e[i][j]] == -)<br />
            {///这条边未被访问过<br />
                nSon[i]++, father[e[i][j]] = i;<br />
                c[i][e[i][j]] = c[e[i][j]][i] = ;<br />
                DFS(e[i][j], );<br />
            }<br />
        }

        if(nSon[i] &gt;=  || e[i].size() == )<br />
            continue;<br />
        ///如果根节点的子树数目小于2,或者只有一个子节点

        for(j=; j&lt;e[i].size(); j++)<br />
        {///从子节点往父节点查找一个节点有大于或等于两个子树的节点<br />
            ///如果找到那么就把这条路径上的所有边取反，如果找不到，无解

            x = e[i][j];

            if(c[x][i] == )<br />
                break;///不需要取反也可以

            while(father[x] != i &amp;&amp; nSon[x] &lt; )<br />
                x = father[x];

            if(father[x] == i)<br />
                continue;///未找到这样的节点

            x = e[i][j];<br />
            c[x][i] = c[i][x] = ;<br />
            while(nSon[x] &lt; )<br />
            {///路径上的边取反<br />
                c[x][father[x]] = c[father[x]][x] = c[x][father[x]] ^ ;<br />
                x = father[x];<br />
            }

            break;<br />
        }

        if(j == e[i].size())<br />
            break;///无解<br />
    }

    if(i &lt;= N)<br />
        printf("No solution\n");<br />
    else<br />
    {<br />
        for(i=; i&lt;=N; i++)<br />
        {<br />
            for(j=; j&lt;e[i].size(); j++)<br />
                printf("%d ", c[i][e[i][j]]+);<br />
            printf("0\n");<br />
        }<br />
    }

    return ;<br />
}<br />
/**<br />
5<br />
2 3 0<br />
1 3 0<br />
1 2 4 5 0<br />
3 5 0<br />
3 4 0<br />
**/</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zeld18.html">ASP&period;NET MVC 网站开发总结（六）&mdash;&mdash;简谈Json的序列化与反序列化</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r2oz7q.html">SQLSERVER迁移工具 SSMA5&period;3发布</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdg3dd8.html">办公软件word使用技巧 - imsoft&period;cnblogs</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wyomlq.html">position绝对剧中</a>
		</li>
						<li><a href="https://www.batexi.com/a/96okww39.html">Android开源项目发现---Menu 篇（持续更新）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdeg2e8.html">Js中单引号和双引号的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkn64j8.html">POJ 1862 &amp;amp&semi;amp&semi; ZOJ 1543 Stripies（贪心 &vert; 优先队列）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yyrjz8.html">遗传算法解决旅行商问题&lpar;TSP&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljnp169.html">安装pip工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j145o8.html">VS2010 express中改变VC Default include&sol;lib&sol;&hellip; 目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp76wvq.html">Javascript中的this关键字用法详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16g7jq.html">sql server 压缩数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1x7ejq.html">第一次连接数据库mongodb踩的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5dnreq.html">定时器setTimeout&lpar;&rpar;和Node&period;js的Event Loop</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj3jm49.html">Dapper&period;NET</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2kd4x9.html">windows安装tomcat</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25pz63q.html">ios－复制字符串到剪贴板</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkk0l18.html">VS2010保存时控件验证&lpar;用onclientclick事件&rpar; js脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qveny6o9.html">MyEclipse项目如何导入到Eclipse</a>
		</li>
						<li><a href="https://www.batexi.com/a/902ny74q.html">基础url、相对url、绝对url</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7mvvmgq.html">java动态绑定的情况分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1665j8.html">使用Gulp构建本地开发Web服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j066k4q.html">朋友的礼物（英雄会&comma;csdn&comma;高校俱乐部）信封问题，匹配模型</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvpwlyq.html">red bottom shoes featured</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdp2z78.html">CSS一级导航-天蓝色（带阴影）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn653rq.html">Maven介绍，包括作用、核心概念、用法、常用命令、扩展及配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm6wnl9.html">python调用java</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj60749.html">mvc Model元数据【学习笔记】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn6gnrq.html">静态代理VS动态代理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2we7moq.html">【itext】7步制作兼容各种文档格式的Itext5页眉页脚 实现page x pf y</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
